VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DBTest"
   ClientHeight    =   2580
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2580
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFindFirstNonIndexed 
      Caption         =   "FindFirst Non-Indexed"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   2055
   End
   Begin VB.CommandButton cmdSeekSecondary 
      Caption         =   "Seek Secondary"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   2040
      Width           =   2055
   End
   Begin VB.CommandButton cmdSeekPrimary 
      Caption         =   "Seek Primary"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   2055
   End
   Begin VB.CommandButton cmdFindFirstPrimary 
      Caption         =   "FindFirst Primary"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   2055
   End
   Begin VB.TextBox txtNumRecords 
      Height          =   285
      Left            =   960
      TabIndex        =   0
      Text            =   "1000"
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdMakeRecords 
      Caption         =   "Make Records"
      Height          =   375
      Left            =   2520
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label lblFindFirstNonIndexed 
      Height          =   255
      Left            =   2400
      TabIndex        =   10
      Top             =   1200
      Width           =   2055
   End
   Begin VB.Label lblSeekSecondary 
      Height          =   255
      Left            =   2400
      TabIndex        =   9
      Top             =   2160
      Width           =   2055
   End
   Begin VB.Label lblSeekPrimary 
      Height          =   255
      Left            =   2400
      TabIndex        =   8
      Top             =   1680
      Width           =   2055
   End
   Begin VB.Label lblFindFirstPrimary 
      Height          =   255
      Left            =   2400
      TabIndex        =   7
      Top             =   720
      Width           =   2055
   End
   Begin VB.Label Label1 
      Caption         =   "# records"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_NumValues As Long
Private m_Values() As Long
Private m_DB As DAO.Database

' Find the values using FindFirst on the primary key in a dynaset.
Private Sub cmdFindFirstPrimary_Click()
Dim start_time As Single
Dim stop_time As Single

Dim i As Long
Dim rs As DAO.Recordset

    lblFindFirstPrimary.Caption = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Create a recordset.
    Set rs = m_DB.OpenRecordset( _
        "SELECT * FROM IndexedTable", _
        Type:=dbOpenDynaset)

    DoEvents
    start_time = Timer
    For i = 1 To m_NumValues
        rs.FindFirst "PrimaryKeyValue=" & i
        If i Mod 10 = 0 Then Caption = i
    Next i
    stop_time = Timer

    rs.Close

    Caption = App.ProductName
    lblFindFirstPrimary.Caption = Format$(stop_time - start_time, "0.00") & " sec"
    Screen.MousePointer = vbDefault
End Sub

' Find the values using Seek on the primary key in a table recordset.
Private Sub cmdSeekPrimary_Click()
Dim start_time As Single
Dim stop_time As Single

Dim i As Long
Dim rs As DAO.Recordset

    lblSeekPrimary.Caption = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Create a recordset.
    Set rs = m_DB.OpenRecordset( _
        "IndexedTable", _
        Type:=dbOpenTable)
    rs.Index = "PrimaryKey"

    DoEvents
    start_time = Timer
    For i = 1 To m_NumValues
        rs.Seek "=", i
        If i Mod 10 = 0 Then
            Caption = i
            DoEvents
        End If
    Next i
    stop_time = Timer

    rs.Close

    Caption = App.ProductName
    lblSeekPrimary.Caption = Format$(stop_time - start_time, "0.00") & " sec"
    Screen.MousePointer = vbDefault
End Sub

Private Sub cmdMakeRecords_Click()
Dim i As Long
Dim j As Long
Dim temp As Long
Dim query As String

    Screen.MousePointer = vbHourglass
    DoEvents

    ' Make an array of values.
    m_NumValues = CLng(txtNumRecords.Text)
    ReDim m_Values(1 To m_NumValues)
    For i = 1 To m_NumValues
        m_Values(i) = i
    Next i

    ' Randomize the array.
    Randomize
    For i = 1 To m_NumValues - 1
        j = Int(i + Rnd * (m_NumValues - i + 1))
        temp = m_Values(i)
        m_Values(i) = m_Values(j)
        m_Values(j) = temp
    Next i

    ' Delete existing entries.
    m_DB.Execute "DELETE FROM IndexedTable"

    ' Create new DB entries.
    For i = 1 To m_NumValues - 1
        query = " (PrimaryKeyValue, IndexedValue, NonIndexedValue) VALUES (" & _
            m_Values(i) & ", " & m_Values(i) & ", " & m_Values(i) & ")"
        m_DB.Execute "INSERT INTO IndexedTable" & query
        If i Mod 10 = 0 Then
            Caption = i
            DoEvents
        End If
    Next i

    Caption = App.ProductName
    Screen.MousePointer = vbDefault
End Sub

' Find the values using Seek on the secondary key in a table recordset.
Private Sub cmdSeekSecondary_Click()
Dim start_time As Single
Dim stop_time As Single

Dim i As Long
Dim rs As DAO.Recordset

    lblSeekSecondary.Caption = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Create a recordset.
    Set rs = m_DB.OpenRecordset( _
        "IndexedTable", _
        Type:=dbOpenTable)
    rs.Index = "SecondaryValue"

    DoEvents
    start_time = Timer
    For i = 1 To m_NumValues
        rs.Seek "=", i
        If i Mod 10 = 0 Then
            Caption = i
            DoEvents
        End If
    Next i
    stop_time = Timer

    rs.Close

    Caption = App.ProductName
    lblSeekSecondary.Caption = Format$(stop_time - start_time, "0.00") & " sec"
    Screen.MousePointer = vbDefault
End Sub

' Find the values using FindFirst on the primary key in a dynaset.
Private Sub cmdFindFirstNonIndexed_Click()
Dim start_time As Single
Dim stop_time As Single

Dim i As Long
Dim rs As DAO.Recordset

    lblFindFirstNonIndexed.Caption = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Create a recordset.
    Set rs = m_DB.OpenRecordset( _
        "SELECT * FROM IndexedTable", _
        Type:=dbOpenDynaset)

    DoEvents
    start_time = Timer
    For i = 1 To m_NumValues
        rs.FindFirst "NonIndexedValue=" & i
        If i Mod 10 = 0 Then Caption = i
    Next i
    stop_time = Timer

    rs.Close

    Caption = App.ProductName
    lblFindFirstNonIndexed.Caption = Format$(stop_time - start_time, "0.00") & " sec"
    Screen.MousePointer = vbDefault
End Sub

Private Sub Form_Load()
Dim db_name As String

    ' Get the database name.
    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    db_name = db_name & "TestData.mdb"

    ' Open the database.
    Set m_DB = DAO.DBEngine(0).OpenDatabase(db_name)
End Sub


Private Sub Form_Unload(Cancel As Integer)
    ' Close the database.
    m_DB.Close
End Sub


